"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.averageBlockTime = void 0;
var tslib_1 = require("tslib");
var TypeGuards_1 = require("./TypeGuards");
var TimeUtils_1 = require("./TimeUtils");
var defaultBlockRange = 120;
var cacheTTL = 60 * 15;
var blockTimes = {};
function averageBlockTime(provider, _a) {
    var _b = _a === void 0 ? {} : _a, latestBlockNumber = _b.latestBlockNumber, blockRange = _b.blockRange;
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var chainId, cache, now, _c, _d, firstBlock, lastBlock, average;
        return tslib_1.__generator(this, function (_e) {
            switch (_e.label) {
                case 0: return [4, provider.getNetwork()];
                case 1:
                    chainId = (_e.sent()).chainId;
                    cache = blockTimes[chainId];
                    now = (0, TimeUtils_1.getCurrentTime)();
                    if ((0, TypeGuards_1.isDefined)(cache) && now < cache.timestamp + cacheTTL) {
                        return [2, { average: cache.average, blockRange: cache.blockRange }];
                    }
                    if (!(latestBlockNumber !== null && latestBlockNumber !== void 0)) return [3, 2];
                    _c = latestBlockNumber;
                    return [3, 4];
                case 2: return [4, provider.getBlockNumber()];
                case 3:
                    _c = (latestBlockNumber = _e.sent());
                    _e.label = 4;
                case 4:
                    _c;
                    blockRange !== null && blockRange !== void 0 ? blockRange : (blockRange = defaultBlockRange);
                    return [4, Promise.all([
                            provider.getBlock(latestBlockNumber - blockRange),
                            provider.getBlock(latestBlockNumber),
                        ])];
                case 5:
                    _d = _e.sent(), firstBlock = _d[0], lastBlock = _d[1];
                    average = (lastBlock.timestamp - firstBlock.timestamp) / blockRange;
                    blockTimes[chainId] = { timestamp: now, average: average, blockRange: blockRange };
                    return [2, { average: average, blockRange: blockRange }];
            }
        });
    });
}
exports.averageBlockTime = averageBlockTime;
//# sourceMappingURL=BlockUtils.js.map